'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDirectories = exports.isDirectory = exports.getEntities = exports.templateCompileAsync = exports.templateAsync = exports.checkCommandAvailableAsync = undefined;

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var checkCommandAvailableAsync = exports.checkCommandAvailableAsync = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(command) {
    var whereResult;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return execAsync('which ' + command);

          case 2:
            whereResult = _context.sent;

            if (!(whereResult.stderr || whereResult.err)) {
              _context.next = 7;
              break;
            }

            return _context.abrupt('return', false);

          case 7:
            return _context.abrupt('return', true);

          case 8:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function checkCommandAvailableAsync(_x) {
    return _ref.apply(this, arguments);
  };
}();

var templateAsync = exports.templateAsync = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(filePath, args) {
    var template;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return readFileAsync(filePath);

          case 2:
            template = _context2.sent;
            return _context2.abrupt('return', _handlebars2.default.compile(template, {
              noEscape: true
            })(args));

          case 4:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function templateAsync(_x2, _x3) {
    return _ref2.apply(this, arguments);
  };
}();

var templateCompileAsync = exports.templateCompileAsync = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(filePath) {
    var template;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return readFileAsync(filePath);

          case 2:
            template = _context3.sent;
            return _context3.abrupt('return', _handlebars2.default.compile(template, {
              noEscape: true
            }));

          case 4:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function templateCompileAsync(_x4) {
    return _ref3.apply(this, arguments);
  };
}();

var getEntities = exports.getEntities = function () {
  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(path) {
    return _regenerator2.default.wrap(function _callee4$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            return _context5.abrupt('return', new _promise2.default(function (resolve, reject) {
              _fs2.default.readdir(path, function (err, files) {
                if (err) {
                  reject(err);
                } else {
                  resolve(files);
                }
              });
            }));

          case 1:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee4, this);
  }));

  return function getEntities(_x6) {
    return _ref4.apply(this, arguments);
  };
}();

var isDirectory = exports.isDirectory = function () {
  var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(path) {
    return _regenerator2.default.wrap(function _callee5$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            return _context6.abrupt('return', new _promise2.default(function (resolve, reject) {
              _fs2.default.stat(path, function (err, stat) {
                if (err) {
                  reject(err);
                } else {
                  resolve(stat.isDirectory());
                }
              });
            }));

          case 1:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee5, this);
  }));

  return function isDirectory(_x7) {
    return _ref5.apply(this, arguments);
  };
}();

var getDirectories = exports.getDirectories = function () {
  var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(srcPath) {
    var files, directories, i, dirName;
    return _regenerator2.default.wrap(function _callee6$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return getEntities(srcPath);

          case 2:
            files = _context7.sent;
            directories = [];
            i = 0;

          case 5:
            if (!(i < files.length)) {
              _context7.next = 14;
              break;
            }

            dirName = _path2.default.join(srcPath, files[i]);
            _context7.next = 9;
            return isDirectory(dirName);

          case 9:
            if (!_context7.sent) {
              _context7.next = 11;
              break;
            }

            directories.push(files[i]);

          case 11:
            i++;
            _context7.next = 5;
            break;

          case 14:
            return _context7.abrupt('return', directories);

          case 15:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee6, this);
  }));

  return function getDirectories(_x8) {
    return _ref6.apply(this, arguments);
  };
}();

exports.promptAsync = promptAsync;
exports.readFileAsync = readFileAsync;
exports.copyDirAsync = copyDirAsync;
exports.writeFileAsync = writeFileAsync;
exports.unlinkAsync = unlinkAsync;
exports.execAsync = execAsync;
exports.watchItr = watchItr;
exports.emptyDirAsync = emptyDirAsync;
exports.globAsync = globAsync;
exports.ensureDirAsync = ensureDirAsync;
exports.ensureFileAsync = ensureFileAsync;
exports.existsAsync = existsAsync;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _handlebars = require('handlebars');

var _handlebars2 = _interopRequireDefault(_handlebars);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _child_process = require('child_process');

var _watch = require('watch');

var _watch2 = _interopRequireDefault(_watch);

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _yargs = require('yargs');

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _prompt = require('prompt');

var _prompt2 = _interopRequireDefault(_prompt);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _marked = /*#__PURE__*/_regenerator2.default.mark(watchItr);

var isDebug = !!_yargs.argv.debug;
_prompt2.default.start();

function promptAsync(property) {
  return new _promise2.default(function (resolve, reject) {
    _prompt2.default.get(property, function (err, result) {
      if (err) {
        reject(err);
      } else {
        resolve(result);
      }
    });
  });
}

function readFileAsync(filePath) {
  return new _promise2.default(function (resolve, reject) {
    _fs2.default.readFile(filePath, 'utf-8', function (err, txt) {
      if (err) {
        reject(err);
      } else {
        resolve(txt);
      }
    });
  });
}

function copyDirAsync(src, dest) {
  var clobber = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var filter = arguments[3];

  if (!filter) {
    filter = function filter() {
      return true;
    };
  }
  return new _promise2.default(function (resolve, reject) {
    _fsExtra2.default.copy(src, dest, {
      clobber: clobber,
      filter: filter
    }, function (err) {
      if (err) {
        reject(err);
        return;
      }
      resolve();
    });
  });
}

function writeFileAsync(filePath, content) {
  return new _promise2.default(function (resolve, reject) {
    _fsExtra2.default.outputFile(filePath, content, function (err) {
      if (err) {
        reject(err);
        return;
      }
      resolve();
    });
  });
}

function unlinkAsync(filePath) {
  return new _promise2.default(function (resolve, reject) {
    _fs2.default.unlink(filePath, function (err) {
      if (err) {
        reject(err);
        return;
      }
      resolve();
    });
  });
}

function execAsync(command) {
  if (isDebug) {
    console.log(_chalk2.default.green('Executing:' + command));
    console.log(_chalk2.default.cyan('PATH:' + process.env.PATH));
  }
  return new _promise2.default(function (resolve) {
    (0, _child_process.exec)(command, function (err, stdout, stderr) {
      resolve({
        stdout: stdout,
        stderr: stderr,
        err: err
      });
    });
  });
}

function watchItr(src, options) {
  var resolver, p;
  return _regenerator2.default.wrap(function watchItr$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          resolver = {};

          _watch2.default.watchTree(src, options, function (f, curr, prev) {
            var result = {};
            if ((typeof f === 'undefined' ? 'undefined' : (0, _typeof3.default)(f)) === "object" && prev == null && curr == null) {
              result = {
                state: "TREE_WALKED",
                hash: f
              };
            } else if (prev === null) {
              result = {
                state: "CREATED",
                stat: curr
              };
            } else if (curr.nlink === 0) {
              result = {
                state: "REMOVED",
                prevStat: prev
              };
            } else {
              result = {
                state: "MODIFIED",
                prevStat: prev,
                currStat: curr
              };
            }
            resolver.resolve(result);
          });

        case 2:
          if (!true) {
            _context4.next = 8;
            break;
          }

          p = new _promise2.default(function (resolve) {
            resolver.resolve = resolve;
          });
          _context4.next = 6;
          return p;

        case 6:
          _context4.next = 2;
          break;

        case 8:
        case 'end':
          return _context4.stop();
      }
    }
  }, _marked, this);
}

function emptyDirAsync(src) {
  return new _promise2.default(function (resolve, reject) {
    _fsExtra2.default.emptyDir(src, function (err) {
      if (err) {
        reject(err);
        return;
      }
      resolve();
    });
  });
}

function globAsync(globRegex) {
  return new _promise2.default(function (resolve, reject) {
    (0, _glob2.default)(globRegex, function (err, files) {
      if (err) {
        reject(err);
        return;
      }
      resolve(files);
    });
  });
}

function ensureDirAsync(path) {
  return new _promise2.default(function (resolve, reject) {
    _fsExtra2.default.ensureDir(path, function (err) {
      if (err) {
        reject(err);
      } else {
        resolve();
      }
    });
  });
}

function ensureFileAsync(path) {
  return new _promise2.default(function (resolve, reject) {
    _fsExtra2.default.ensureFile(path, function (err) {
      if (err) {
        reject(err);
      } else {
        resolve();
      }
    });
  });
}

function existsAsync(path) {
  return new _promise2.default(function (resolve, reject) {
    _fs2.default.stat(path, function (err) {
      if (err === null) {
        resolve(true);
      } else if (err.code == 'ENOENT') {
        // file does not exist
        resolve(false);
      } else {
        reject('Some other error: ', err.code);
      }
    });
  });
}