"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _asyncHelper = require("../async-helper");

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getShortDescription(desc) {
  var index = desc.indexOf("\n");
  if (index === -1) {
    return desc;
  }
  var shortDesc = desc.substr(0, index);
  if (shortDesc.trim().length === 0) {
    shortDesc = getShortDescription(desc.substr(index + 1));
  }
  return shortDesc;
}

function fixBreakLine(desc) {
  return desc.replace(/\n/g, "  \n");
}

function reformat(jsonData) {
  jsonData.short_name = jsonData.name.replace("grimoirejs", "grimoire");
  for (var key in jsonData.components) {
    var comp = jsonData.components[key];
    comp.short_description = getShortDescription(comp.description);
    comp.description = fixBreakLine(comp.description);
    for (var attr in comp.attributes) {
      var attrV = comp.attributes[attr];
      if (attrV.default === "") {
        attrV.default = "(Empty string)";
      }
      attrV.short_description = getShortDescription(attrV.description);
      attrV.description = fixBreakLine(attrV.description);
    }
  }
  for (var _key in jsonData.nodes) {
    var node = jsonData.nodes[_key];
    node.short_description = getShortDescription(node.description);
    node.description = fixBreakLine(node.description);
  }
  for (var _key2 in jsonData.converters) {
    var conv = jsonData.converters[_key2];
    conv.short_description = getShortDescription(conv.description);
    conv.description = fixBreakLine(conv.description);
  }
  return jsonData;
}

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(input) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _asyncHelper.templateAsync)(_path2.default.normalize(__dirname + "/../../src/doc/templates/api-reference.md"), reformat(input));

          case 2:
            return _context.abrupt("return", _context.sent);

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function generate(_x) {
    return _ref.apply(this, arguments);
  }

  return generate;
}();