"use strict";

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var init = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    var suffix, bp, cwd;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            suffix = (0, _common.getSuffix)(_yargs.argv.name);

            if (suffix) {
              try {
                bp = _yargs.argv.js ? js_boilerplate : ts_boilerplate;
                cwd = process.cwd();

                console.log("cloning boilerplate from " + bp + " ...");
                git.clone(bp, cwd).removeRemote("origin", function () {
                  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(e) {
                    var path_README, package_json;
                    return _regenerator2.default.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            if (e) {
                              console.error(e);
                            }

                            _fsExtra2.default.removeSync(_path2.default.join(cwd, ".git"));

                            path_README = _path2.default.join(cwd, "README.md");

                            (0, _asyncHelper.writeFileAsync)(path_README, "# grimoire-" + suffix + "\nplugin for Grimoire.js(https://grimoire.gl).\n");

                            _context.next = 6;
                            return (0, _asyncHelper.readFileAsync)(_path2.default.join(cwd, "package.json"));

                          case 6:
                            package_json = _context.sent;

                            package_json = package_json.replace(/"name" *: *"[^"]*"/, "\"name\": \"grimoirejs-" + suffix + "\"");
                            package_json = package_json.replace(/"description" *: *"[^"]*"/, "\"description\": \"\"");
                            package_json = package_json.replace(/"version" *: *"[^"]*"/, "\"version\": \"0.0.1\"");
                            _context.next = 12;
                            return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, "package.json"), package_json.replace('"name": "grimoirejs-ts-boilerplate"', "\"name\": \"grimoire-" + suffix + "\""));

                          case 12:
                            git.init().add("./*").commit("Initial commit.");

                          case 13:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, this);
                  }));

                  return function (_x) {
                    return _ref2.apply(this, arguments);
                  };
                }());
              } catch (e) {
                console.error(e);
              }
            } else {
              console.warn("invalid name.");
            }

          case 2:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function init() {
    return _ref.apply(this, arguments);
  };
}();

var _simpleGit = require("simple-git");

var _simpleGit2 = _interopRequireDefault(_simpleGit);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _fsExtra = require("fs-extra");

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _common = require("../buildUtil/common");

var _yargs = require("yargs");

var _asyncHelper = require("../async-helper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var git = (0, _simpleGit2.default)();


var ts_boilerplate = "https://github.com/GrimoireGL/ts-boilerplate.git";
var js_boilerplate = "https://github.com/GrimoireGL/js-boilerplate.git";

init();