"use strict";

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _yargs = require("yargs");

var _asyncHelper = require("../async-helper");

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _chalk = require("chalk");

var _chalk2 = _interopRequireDefault(_chalk);

var _findRoot = require("find-root");

var _findRoot2 = _interopRequireDefault(_findRoot);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var projroot = (0, _findRoot2.default)(process.cwd());
var templateDir = _path2.default.join(__dirname, "../../src/scaffold/templates/");

var writeScaffoled = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(path, content) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.t0 = !_yargs.argv.force;

            if (!_context.t0) {
              _context.next = 5;
              break;
            }

            _context.next = 4;
            return (0, _asyncHelper.existsAsync)(path);

          case 4:
            _context.t0 = _context.sent;

          case 5:
            if (!_context.t0) {
              _context.next = 9;
              break;
            }

            console.log(_chalk2.default.bgRed.white("Specified component already existing. To prevent overwrite modified files, scaffolded result was not generated.\nHowever, if this action was intended, you can use '--force' option to overwrite."));
            _context.next = 11;
            break;

          case 9:
            _context.next = 11;
            return (0, _asyncHelper.writeFileAsync)(path, content);

          case 11:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function writeScaffoled(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var scaffold = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    var type, templated, upperType, test;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            type = _yargs.argv.type.toLowerCase();

            if (_yargs.argv.name) {
              _context2.next = 4;
              break;
            }

            console.log("please specify " + type + " name you want to scaffold with -n option");
            return _context2.abrupt("return");

          case 4:
            _context2.next = 6;
            return (0, _asyncHelper.templateAsync)(templateDir + type + ".template", {
              name: _yargs.argv.name
            });

          case 6:
            templated = _context2.sent;
            upperType = type.substr(0, 1).toUpperCase() + type.substring(1);
            _context2.next = 10;
            return writeScaffoled(_path2.default.join(projroot, "src/" + upperType + "s/" + _yargs.argv.name + (upperType + ".ts")), templated);

          case 10:
            if (!(type === "converter")) {
              _context2.next = 16;
              break;
            }

            _context2.next = 13;
            return (0, _asyncHelper.templateAsync)(templateDir + "converter_test.template", {
              key: _yargs.argv.name + "Converter",
              path: _yargs.argv.name + "Converter"
            });

          case 13:
            test = _context2.sent;
            _context2.next = 16;
            return writeScaffoled(_path2.default.join(projroot, "test/Converters/" + _yargs.argv.name + "ConverterTest.js"), test);

          case 16:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function scaffold() {
    return _ref2.apply(this, arguments);
  };
}();

scaffold();